#ifndef TEST_BOOL_H_
#define TEST_BOOL_H_

#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <stack>

#include "POOLCore/win32/stl_hash.h"
#include <set>
#include <map>

struct test_bool {
  std::pair<bool,bool>                  m_bool_pair;
  std::vector<bool>                     m_bool_vector;
  std::list<bool>                       m_bool_list;

  std::multimap<bool, int>              m_bool_int_multimap;
  std::multimap<int, bool>              m_int_bool_multimap;
  STDEXT::hash_map<int, bool>        m_int_bool_hash_map;
  STDEXT::hash_map<bool, int>        m_bool_int_hash_map;
  STDEXT::hash_multimap<int, bool>   m_int_bool_hash_multimap;
  STDEXT::hash_multimap<bool, int>   m_bool_int_hash_multimap;
  STDEXT::hash_set<bool>             m_bool_hash_set;
  STDEXT::hash_multiset<bool>        m_bool_hash_multiset;
  std::multiset<bool>                   m_bool_multiset;
  std::set<bool>                        m_bool_set;
  std::deque<bool>                      m_bool_deque;
  std::queue<bool>                      m_bool_queue;
  std::stack<bool>                      m_bool_stack;

  /**
    *       class implementation
    */
  /// Standard Constructor
  test_bool();
  /// Standard destructor
  virtual ~test_bool();
  void fillData(int i);
  void printData(int i);
};

#endif // TEST_BOOL_H_
