#include "StorageSvc/pool.h"
#include "pool/test_bool.h"
#include <limits>
#include <iostream>
#include <iomanip>
namespace pool  {
  typedef bool Bool_t;
}

template <typename T> static inline
std::ostream& out(std::ostream& os, const T& p) 
{  return os << p;  }
template<> static inline std::ostream& out(std::ostream& os, const bool& p) 
{  return os << (char*)(p ? "T" : "F");  }

template <typename T, typename Q> static inline
std::ostream& operator<<(std::ostream& os, const std::pair<T,Q>& p) 
{  os << "("; out(os,p.first); os << ","; out(os,p.second); return os << ")"; }


template <typename T> static
void dumpContainer(const std::string& dsc, const T& cnt) {
  typedef typename T::const_iterator IT;
  std::cout << dsc;
  for(IT i = cnt.begin(); i != cnt.end(); ++i) {
    out(std::cout, (*i));
    std::cout << " ";
  }
  std::cout << std::endl;
}
template <typename T> static
std::ostream& operator<< (std::ostream& os, std::queue<T>& cnt) {
  for (size_t i = 0; i < cnt.size(); ++i)  {
    out(os, cnt.front()); std::cout << " ";
    cnt.push(cnt.front());
    cnt.pop();
  }
  return os;
}
template <typename T> static
std::ostream& operator<< (std::ostream& os, std::stack<T>& cnt) {
  for (size_t i = 0, _n=cnt.size(); i<_n; ++i)  {
    out(os, cnt.top()); std::cout << " ";
    cnt.pop();
  }
  return os;
}

test_bool::test_bool()  {
}

test_bool::~test_bool() {
}

void test_bool::fillData(int /*j*/)    {
  bool val = true;
  for (int i = 0; i < 10; ++i)  {
    val = !val;
    m_bool_pair.first = val;
    m_bool_pair.second = !val;
    m_bool_list.push_back(val);
    m_bool_vector.push_back(val);
    m_bool_int_multimap.insert(std::make_pair(val, i));
    m_int_bool_multimap.insert(std::make_pair(i, val));
    m_bool_int_hash_map.insert(std::make_pair(val, i));
    m_int_bool_hash_map.insert(std::make_pair(i, val));
    m_bool_hash_set.insert(val);
    m_bool_hash_multiset.insert(val);
    m_bool_multiset.insert(val);
    m_bool_set.insert(val);
    m_bool_deque.push_back(val);
    m_bool_queue.push(val);
    m_bool_stack.push(val);
  }
}

void test_bool::printData(int /* i */ )
{
  std::cout <<  " m_bool_pair:          "; out(std::cout,m_bool_pair) << std::endl;
  dumpContainer(" m_bool_list:          ", m_bool_list);
  dumpContainer(" m_bool_vector:        ", m_bool_vector);
  dumpContainer(" m_bool_int_multimap:  ", m_bool_int_multimap);
  dumpContainer(" m_int_bool_multimap:  ", m_int_bool_multimap);
  dumpContainer(" m_bool_int_hash_map:  ", m_bool_int_hash_map);
  dumpContainer(" m_int_bool_hash_map:  ", m_int_bool_hash_map);
  dumpContainer(" m_bool_hash_set:      ", m_bool_hash_set);
  dumpContainer(" m_bool_hash_multiset: ", m_bool_hash_multiset);
  dumpContainer(" m_bool_multiset:      ", m_bool_multiset);
  dumpContainer(" m_bool_set:           ", m_bool_set);
  dumpContainer(" m_bool_deque:         ", m_bool_deque);
  std::cout <<  " m_bool_queue:         " << m_bool_queue << std::endl;
  std::cout <<  " m_bool_stack:         " << m_bool_stack << std::endl;
}
