#include "AttributeList/AttributeSpecification.h"
#include "AttributeList/AttributeTypes.h"
#include <ostream>

pool::AttributeSpecification::~AttributeSpecification()
{}

void
pool::AttributeSpecification::print(std::ostream&os) const
{
  os << name() << ":" << type_name();
}


pool::AttributeSpecification::AttributeSpecification( std::string name,
                                                      const std::type_info& typeInfo ):
  m_name( name ),
  m_type_info( &typeInfo )
{}


pool::AttributeSpecification::AttributeSpecification( std::string name,
                                                      std::string type_name ):
  m_name( name ),
  m_type_info( pool::AttributeImplFactory::theFactory().typeOfAttributeObject( type_name ) )
{}


std::string
pool::AttributeSpecification::type_name() const
{
  return pool::AttributeImplFactory::theFactory().typeNameOfAttributeObject( *m_type_info );
}
