//$Id: FCEntry.h,v 1.1 2003/09/25 15:21:08 moscicki Exp $
#ifndef POOL_FCENTRY_H
#define POOL_FCENTRY_H
#include <string>
#include <iostream>
#include "AttributeList/AttributeList.h"

namespace pool{
  class FCEntry{
  public:
    FCEntry() : m_spec(new AttributeListSpecification) {}
    ~FCEntry(){}
    AttributeList& attrs()const{
      return *m_attrs;
    }
  protected:

    void initAttrs()
    {
      m_attrs.reset(new AttributeList(m_spec));
    }

    boost::shared_ptr<AttributeListSpecification> m_spec;
    boost::shared_ptr<AttributeList> m_attrs;
  };
  

  class PFNEntry:public FCEntry{
    
  public:
    PFNEntry(){
      std::cout<<"default constructor"<<std::endl;
      m_spec->push_back( "guid", "string");
      m_spec->push_back( "pfname", "string");
      m_spec->push_back( "filetype", "string");
      initAttrs();
    }
    ~PFNEntry(){
    }
    PFNEntry(const std::string& ipfname, 
             const std::string& iguid,
	     const std::string& ifiletype ){
      std::cout<<"constructor"<<std::endl;
      m_spec->push_back( "guid", "string");
      m_spec->push_back( "pfname", "string");
      m_spec->push_back( "filetype", "string");
      initAttrs();

      this->setValue(ipfname,iguid,ifiletype);
    }
    PFNEntry(const PFNEntry& pentry):FCEntry(){
      std::cout<<"copy constructor"<<std::endl;
      std::string ipfname=pentry.attrs()["pfname"].getValueAsString();
      std::string iguid=pentry.attrs()["guid"].getValueAsString();
      std::string ifiletype=pentry.attrs()["filetype"].getValueAsString();

      m_spec = pentry.m_spec;
      initAttrs(); 

      std::cout<<"m_attrs "<<m_attrs<<std::endl; 
      this->setValue(ipfname,iguid,ifiletype);
      std::cout<<"fini"<<std::endl;
    }
    void setValue(const std::string& ipfname, 
		  const std::string& iguid, 
		  const std::string& ifiletype 
		  ){
      (*m_attrs)["guid"].setValue(iguid);
      (*m_attrs)["pfname"].setValue(ipfname);
      (*m_attrs)["filetype"].setValue(ifiletype);
    }
    void print(std::ostream& os)const{
      //AttributeListSpecification spec=attrs().attributeListSpecification();
      //std::cout<<spec.size()<<std::endl;
      m_attrs->print(os);
    }
  };
  //inline std::ostream& operator << (std::ostream&s, const PFNEntry& p){
  // p.attrs().print(s);
  // return s;
  //}
  
}//ns pool
#endif
