
#include "POOLCore/Token.h"
#include "StorageSvc/DbReflex.h"
#include "Reflex/Base.h"


template<class T> inline
bool
pool::CollectionProxy::Iterator::isCurrentObjectOfType() const
{
   if ( m_valid ) {
      getTokenFromCursor(); 
      ROOT::Reflex::Type thisClassType = ROOT::Reflex::Type::ByTypeInfo( typeid(T) );
      ROOT::Reflex::Type persistentClass = pool::DbReflex::forGuid( m_token->classID() );

      if( persistentClass == thisClassType ) {
	 //std::cout << "Collection iterator token type match for " << persistentClass.Name() <<  std::endl;
	 return true;
      }
      if( persistentClass.HasBase( thisClassType ) ) {        
	 //std::cout << "Collection iterator token base-type match" << std::endl;
	 return true;
      }
   }
   return false;
}


template<class T> inline
pool::Ref<T>
pool::CollectionProxy::Iterator::ref() const
{
   if( m_valid ) {
      getTokenFromCursor(); 
      // std::cout << "Collection Iterator constructing reference for " << m_token->toString() << std::endl;
      return pool::Ref<T>( m_dataSvc, *m_token );
   }
   else {
      return pool::Ref<T>();
   }
}


inline bool
pool::CollectionProxy::Iterator::isValid() const {
  return m_valid;
}
