#ifndef POOL_ANYTYPE_H
#define POOL_ANYTYPE_H

#include <typeinfo>
#include <string>
#include "Reflex/Type.h"

#include "RVersion.h"
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
typedef ROOT::Reflex::Type TypeH;
#else
typedef Reflex::Type TypeH;
#endif

namespace pool{

  class Guid;

  class AnyType {

  public: 
    
    AnyType();

    AnyType(const std::type_info& type);

    AnyType(const TypeH& c);
                     
    AnyType(const AnyType& aType);

    virtual ~AnyType();

    AnyType& operator=(const AnyType& aType);

    AnyType& operator=(const std::type_info& type);

    AnyType& operator=(const TypeH& aClass);

    operator bool() const;

    const std::type_info* getType() const; 

    std::string name() const;

    const TypeH& getClass() const; 

    void* cast(const AnyType& asType, const void* aPtr) const;

    bool hasBase(const AnyType& aBaseType) const;

    bool isBaseFor(const AnyType& forType) const;

    void destroy(void* aPtr);

    void reset();

  private:

    TypeH m_class;

    std::string m_className;

  };

}

#endif
