#ifndef POOL_DATASVCFACTORY_H
#define POOL_DATASVCFACTORY_H

#include "DataSvc/ObjectDeletePolicy.h"

namespace pool    {

  class IPersistencySvc;
  class ITokenValidator;
  class IDataTransform;
  class IFileCatalog;
  class IDataSvc;
  class DataSvcContext;

/** @class DataSvcFactory DataSvcFactory.h
    Convenience class implementing a proxy for the access to the cache table.

    @author Giacomo Govi
    @date 25/07/2002
**/
  class DataSvcFactory  {

    public:
    // deprecated (method name wrongly suggests singleton pattern) 
    static IDataSvc* instance(IPersistencySvc* aPersSvc); 

    // deprecated (method name wrongly suggests singleton pattern)
    static IDataSvc* instance(IFileCatalog* aFileCatalog,
                              ITokenValidator* aTokenValidator = 0,
                              IDataTransform* aDataTransform = 0,
                              ObjectDeletePolicy aDeletePolicy=
                                ObjectDeletePolicy::defaultPolicy());

    // deprecated (method name wrongly suggests singleton pattern)
    static IDataSvc* instance(const DataSvcContext&);

    static IDataSvc* create(IPersistencySvc* aPersSvc); 

    static IDataSvc* create(IFileCatalog* aFileCatalog,
                              ITokenValidator* aTokenValidator = 0,
                              IDataTransform* aDataTransform = 0,
                              ObjectDeletePolicy aDeletePolicy=
                                ObjectDeletePolicy::defaultPolicy());

    static IDataSvc* create(const DataSvcContext&);
  };   // class DataSvcFactory
}      // namespace pool

#endif  // POOL_DATASVCFACTORY_H
