#ifndef OBJECTRELATIONALACCESS_OBJECTRELATIONALCLASSUTILS_H
#define OBJECTRELATIONALACCESS_OBJECTRELATIONALCLASSUTILS_H

#include "Reflex/Type.h"
#include "RVersion.h"
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
using namespace ROOT;
#endif 

namespace pool {

  class ObjectRelationalClassUtils {

  public:

    static bool isTypeContainer(const Reflex::Type& typ);

    static bool isTypeKeyedContainer(const Reflex::Type& typ);

    static bool isTypeNonKeyedContainer(const Reflex::Type& typ);

    static bool isTypeAssociativeContainer(const Reflex::Type& typ);

    static bool isTypeNonAssociativeContainer(const Reflex::Type& typ);

    static Reflex::Type containerValueType(const Reflex::Type& typ);
    
    static Reflex::Type containerKeyType(const Reflex::Type& typ);
    
    static Reflex::Type containerDataType(const Reflex::Type& typ);
    
    static Reflex::Type resolvedType(const Reflex::Type& typ);
    
    static bool isTypePoolPointer( const Reflex::Type& typ);
    
    static bool isTypePoolPolymorphicPointer( const Reflex::Type& typ);
    
    static bool isTypePVector( const Reflex::Type& typ);

    static bool isTypeObject( const Reflex::Type& typ);
  };

}

#endif
