#ifndef POOLCORE_CONTEXT_H
#define POOLCORE_CONTEXT_H

namespace coral {
  class IConnectionService;
}

namespace pool {

  class IBlobStreamingService;

  /// Class defining the entry point to the framework component model for POOL.
  class Context {
  public:

    Context();

    virtual ~Context();

    void setBlobStreamer(pool::IBlobStreamingService* service, bool giveUpOwnership=true);
    
    pool::IBlobStreamingService* blobStreamer();

    void setConnectionService(coral::IConnectionService* service, bool giveUpOwnership=true);

    coral::IConnectionService* connectionService();

    private:

    pool::IBlobStreamingService* m_blobStreamingService;

    bool m_blobStreamingServiceOwnership;

    coral::IConnectionService* m_connectionService;

    bool m_connectionServiceOwnership;
    
  };

}

inline
coral::IConnectionService*
pool::Context::connectionService(){
  return m_connectionService;
}

inline
pool::IBlobStreamingService*
pool::Context::blobStreamer(){
  return m_blobStreamingService;
}

#endif
