#include "PVectorContainerIteratorHandler.h"
#include "RelationalStorageServiceException.h"
#include "Reflex/Object.h"

pool::RelationalStorageService::PVectorContainerIteratorHandler::PVectorContainerIteratorHandler( const Reflex::Environ<long>& collEnv,
                                                                                                  Reflex::CollFuncTable* collProxy,
                                                                                                  const Reflex::Type& iteratorReturnType,
                                                                                                  size_t startElement):
  m_returnType(iteratorReturnType),
  m_collEnv(collEnv),
  m_collProxy(collProxy),
  m_currentElement(0),
  m_startElement(startElement){

  // retrieve the first element
  if(m_collProxy){    
    m_currentElement = m_collProxy->first_func(&m_collEnv);
  }
  if(startElement){
    size_t i = 0;
    while(i<startElement){
      increment();
      i++;
    }
  } 
}

pool::RelationalStorageService::PVectorContainerIteratorHandler::~PVectorContainerIteratorHandler(){}

void
pool::RelationalStorageService::PVectorContainerIteratorHandler::increment()
{
  if(m_collProxy){
    // this is required! It sets the number of memory slots (of size sizeof(Class)) to be used for the step 
#if ROOT_VERSION_CODE >= ROOT_VERSION(5,22,0)
    m_collEnv.fIdx = 1;
#else
    m_collEnv.idx = 1;
#endif
    m_currentElement = m_collProxy->next_func(&m_collEnv);
  }
}


void*
pool::RelationalStorageService::PVectorContainerIteratorHandler::object()
{
  return m_currentElement;
}


Reflex::Type
pool::RelationalStorageService::PVectorContainerIteratorHandler::returnType() const
{
  return m_returnType;
}
