#ifndef IOODATABASEFACTORY_H
#define IOODATABASEFACTORY_H

#include "Reflex/PluginService.h"
#include "StorageSvc/IOODatabase.h"
#include "RVersion.h"
#include <new>
// Reflex object factory definition
namespace {
  template <typename P> class Factory<P,pool::IOODatabase*(void*)> {
#if ROOT_VERSION_CODE < ROOT_VERSION(5,21,3)
  public: static void* Func( void*, const std::vector<void*>& arg, void*)
    { return (pool::IOODatabase*)(new P(arg[0]));                   }
#else
  public: static void Func( void* ret, void* mem, const std::vector<void*>& arg, void*)     {
    void* p = (pool::IOODatabase*)(mem ? ::new(mem) P(arg[0]) : ::new P(arg[0]));
    if (ret) *(void**)ret = p;
  }
#endif
  };
}
#define DECLARE_OODATABASE(x) PLUGINSVC_FACTORY(x,pool::IOODatabase*(void*))
#endif
