// $Id: DbDatabaseImp.cpp,v 1.13 2008/10/21 08:39:59 frankb Exp $
//====================================================================
//
//  Package    : StorageSvc (The POOL project)
//
//  @author      M.Frank
//
//====================================================================

/// Framework include files
#include "StorageSvc/DbDatabaseImp.h"
#include "StorageSvc/DbInstanceCount.h"
using namespace pool;

static DbInstanceCount::Counter* s_count = DbInstanceCount::getCounter(typeid(DbDatabaseImp));

/// Standard Constructor
DbDatabaseImp::DbDatabaseImp(IOODatabase* idb)  : DbImplementation(idb)
{  s_count->increment();                                                }

/// Standard Destructor
DbDatabaseImp::~DbDatabaseImp()
{  s_count->decrement();                                                }

/// Callback after successful open of a database object
DbStatus DbDatabaseImp::onOpen(const DbDatabase& /* dbH  */,DbAccessMode /* mode */)
{  return Success;                                                      }

/// Re-open database with changing access permissions
DbStatus DbDatabaseImp::reopen(DbAccessMode /* mode */)
{  return Error;                                                        }

/// Find container in Database: to be overridden
DbStatus DbDatabaseImp::find(DbContainer& /* handle */)
{  return Success;                                                      }

/// Access options
DbStatus DbDatabaseImp::getOption(DbOption& /* opt */) const
{  return Error;                                                        }

/// Set options
DbStatus DbDatabaseImp::setOption(const DbOption& /* opt */)
{  return Success;                                                      }

/// Start/Commit/Rollback Database Transaction
DbStatus DbDatabaseImp::transAct(DbTransaction& /* refTr */)
{  return Success;                                                      }
