//  $Header: /cvs/PF/pool/StorageSvc/src/DbOptionCallback.cpp,v 1.8 2007/11/20 16:43:10 frankb Exp $
//  ====================================================================
//  Transaction.cpp
//  --------------------------------------------------------------------
//
//  Package   : POOLCore
//
//  Author    : Markus Frank
//
//  ====================================================================
#include "StorageSvc/DbOptionCallback.h"
using namespace pool;

static DbOptionCallback* s_actualCall = 0;

/// Standard destructor
DbOptionCallback::DbOptionCallback()  {
}

/// Destructor with initialization (from STACK ONLY!)
DbOptionCallback::DbOptionCallback(DbOptionCallback* cb)  {
  s_actualCall = cb;
}

/// Standard destructor
DbOptionCallback::~DbOptionCallback() {
  s_actualCall = 0;
}

/// Set options to me
DbStatus DbOptionCallback::getOptions(IDbOptionProxy* pObj, 
                                      OptionType typ, 
                                      const std::string& name)
{
  if ( s_actualCall )  {
    return s_actualCall->setMyOptions(pObj, typ, name);
  }
  return Success;
}

/// Default callback (does nothing)
DbStatus DbOptionCallback::setMyOptions( IDbOptionProxy*    /* pObj */, 
                                         OptionType         /* typ  */, 
                                         const std::string& /* name */)
{
  return Success;
}

