#!/bin/csh

if ( $#argv != 2 ) goto usage

which scram >& /dev/null
if ( $status != 0 ) then
  echo "I'm not finding scram please, update your $PATH variable"
  echo Fatal Error
  exit 1
endif
eval `scram runtime -csh`
if ( $status != 0 ) then
  echo Fatal Error
  exit 2
endif

which FCpublish >& /dev/null
if ( $status != 0 ) then
  echo "I cannot find the line command tools Utilities/FileCatalog"
  echo Fatal Error
  exit 3
endif

set oldcat = $1
if ( ! -e $oldcat ) then
  echo POOL_1 Old Catalog $oldcat does not exists, do nothing
  exit 4
endif
set newcat = $2
if ( -e $newcat ) then
  echo File $newcat already exists, do nothing
  exit 5
endif

set npfn = `grep pfname $oldcat | wc -l`
FCpublish -u file:$oldcat -d file:$newcat -m $npfn >& /dev/null

exit 0
usage:
echo Usage: migrate_POOL1toPOOL1.4.csh  p1_catalog    p1.4_catalog
exit 10
