#ifndef TESTBASE_H
#define TESTBASE_H

#include <string>

namespace seal {
  class Context;
}

namespace pool {
  class IFileCatalogImpl;
}

class TestBase
{
public:
  // Constructor
  TestBase();

  // Destructor
  virtual ~TestBase();

  // The actual run method
  virtual void run() = 0;

protected:
  // Resets the catalog
  void resetCatalog( const std::string& connectionString );

  // Returns a session object
  pool::IFileCatalogImpl* retrieveCatalog( const std::string& connectionString );

private:
  // The local context
  seal::Context* m_context;
};

#endif
