#include "Stat.h"
#include <iomanip>


Stat::Stat(){}
Stat::~Stat(){}

void Stat::setInfo(std::string& message, long long  value){
  int ncall = 1;
  if (results.find(message) != results.end()){
    results[message] += value;
    ncall = counts[message]++;
  }else{
    counts [message] = ncall;
    results[message] = value;
  }
}

void Stat::print(){
  std::map<std::string, long long >::iterator iresul;
  std::map<std::string, int  >::iterator icount=counts.begin();
  std::cout<<std::setw(100)<<std::setfill('+')<<" "<<std::endl;

  unsigned int maxstr = 0;
  for (iresul=results.begin();
       iresul!=results.end(); iresul++){
    if ( ((*iresul).first).size()>maxstr ) maxstr=(*iresul).first.size();
  }

  for (iresul=results.begin();
       iresul!=results.end(); iresul++){
    unsigned int siztr = (*iresul).first.size();
    std::cout<<std::setfill(' ')
             <<(*iresul).first<<std::setw(maxstr-siztr+1)<<" ";

    std::cout<<std::setw(13)<<"time spent "<<std::setw(12)
             <<(*iresul).second<< " called "<<std::setw(8)
             <<(*icount).second<<" times"
             <<" Average time "
             << (float)((*iresul).second) / (float)((*icount).second)/1000.
             <<" msec"
             <<std::endl;
    icount++;
  }

  std::cout<<std::setw(100)<<std::setfill('=')<<" "<<std::endl;

}
